<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <meta http-equiv="X-UA-Compatible" content="ie=edge" />
        <title>Twilio Flex - Ticket Sidebar</title>
        <link href="https://fonts.googleapis.com/css?family=Open+Sans" rel="stylesheet" />
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-uWxY/CJNBR+1zjPWmfnSnVxwRheevXITnMqoEIeG1LJrdI0GlVs/9cVSyPYXdcSF" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.1/font/bootstrap-icons.css">

        <script type="text/javascript" src="https://static.zdassets.com/zendesk_app_framework_sdk/2.0/zaf_sdk.min.js"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>

        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-kQtW33rZJAHjgefvhyyzcGF3C5TFyBQBA13V1RKPf4uH+bwyzQxZ6CmMZHmNBEfJ" crossorigin="anonymous"></script>
        <style>
            body {font-size: .7rem !important; }
            .btn { font-size: .7rem !important; }

            #sendMessage { float:right !important;}
        </style>
    </head>
    <body>
        <div id="root" class="container wrapper">
            <!-- create bootstrap form for Flex Contact Panel -->

            <div class="row">
                <div class="col col-lg-12"><p>Enter a Message <span id="info"></span></p></div>
            </div>
            <div class="row">
                <div class="col col-lg-12"><textarea cols="60" rows="5" id="message"></textarea></div>
            </div>                        
            <div class="row">
                <div class="col col-lg-12"><a id="sendMessage" class="btn btn-primary btn-sm" onclick="return false;">Send Message</a></div>
            </div>               
        </div>
        <input id="contactMobile" type="hidden" value="" />
        <script>
            $(function (){
                function getUrlParameter(name) {
                    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
                    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
                    var results = regex.exec(location.search);
                    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
                };


                // ZD client var
                var client;
                var backgroundInstanceGuid;

                let phone = getUrlParameter('phone')
                let name = getUrlParameter('name');
                $('#contactMobile').val(phone);
                $('#info').html(' ( ' + name + ': ' + phone + ' )')
                console.log('phone', phone) 


                // handler to execute upon instantiation (active) of the sidebar extension
                function activate() {
                    // client.get('deal')
                    //     .then(deal =>{
                    //     console.log('===== modal: DEAL =======')
                    //     console.log(deal);
                    //     })
                    // client.get('deal.contact')
                    //     .then(contact =>{
                    //         console.log('===== modal: DEAL CONTACT =======')
                    //         console.log(contact);
                    //         return;
                    //     });

                }                 
                
                function onAppActivated() {
                    if (!backgroundInstanceGuid) {
                    return;
                    }
        
                    client.instance(backgroundInstanceGuid).trigger('deal.app.activated', {
                    ticketId: client._context.ticketId,
                    instanceGuid: client._context.instanceGuid,
                    });
                }
  
                function onAppDeactivated() {
                    if (!backgroundInstanceGuid) {
                    return;
                    }
                    client.instance(backgroundInstanceGuid).trigger('deal.app.deactivated');
                }
                //    initialize the ZAF client
                function init() {
                    client.get('instances').then(function(data) {
                    Object.keys(data.instances).forEach(function(instanceGuid) {
                        if (data.instances[instanceGuid].location === 'background') {
                        backgroundInstanceGuid = instanceGuid;
                        }
                    });
        
                    if (backgroundInstanceGuid) {
                        activate();
                        onAppActivated();
                        return;
                    }
        
                    setTimeout(function() {
                        init();
                    }, 250);
                    });
                }
                
                // Initialise the Zendesk JavaScript API client
                client = ZAFClient.init();
                console.log('modal', client)
                //    ZAF client event handlers
                client.on('app.registered', init);
                client.on('app.activated', onAppActivated);
                client.on('app.deactivated', onAppDeactivated);  
                
                
                // handler for send SMS message
                $('#sendMessage').on('click', function(){
                    let contactMobile = $('#contactMobile').val();
                    let message = $('#message').val();
                    console.log('send message');
              console.log('backGuid', backgroundInstanceGuid);                    
                    client.instance(backgroundInstanceGuid).trigger('send_sms_message', {
                        type: 'deal',
                        contactMobile: contactMobile,
                        message: message,
                        instanceGuid: client._context.instanceGuid
                    })              
                });                
            });
        </script>
    </body>
</html>